diff --git a/src/filebuf.c b/src/filebuf.c
index 1694d576543..cedf4990635 100644
--- a/src/filebuf.c
+++ b/src/filebuf.c
@@ -61,7 +61,7 @@ static int lock_file(git_filebuf *file, int flags, mode_t mode)
 			return res;
 	}
 
-	file->fd = git_futils_creat_locked(file->path_lock, mode);
+	file->fd = git_futils_creat_locked(file->path_lock, mode, flags & GIT_FILEBUF_USE_MMAP);
 
 	if (file->fd < 0)
 		return file->fd;
@@ -143,6 +143,18 @@ int git_filebuf_flush(git_filebuf *file)
 
 GIT_INLINE(bool) do_write(git_filebuf *file, void *source, size_t len)
 {
+#ifdef GIT_WIN32
+	if (0 <= file->map_pos) {
+		const bool ok = 0 <= p_mmap_write_at(
+			source, len, file->fd, file->map_pos);
+		if (ok)
+			file->map_pos += len;
+		else
+			file->last_error = BUFERR_WRITE;
+		return ok;
+	}
+#endif
+
 	if (0 <= p_write(file->fd, source, len))
 		return true;
 	file->last_error = BUFERR_WRITE;
@@ -216,6 +228,7 @@ int git_filebuf_open(git_filebuf *file, const char *path, int flags, mode_t mode
 	file->buf_pos = 0;
 	file->fd = -1;
 	file->last_error = BUFERR_OK;
+	file->map_pos = flags & GIT_FILEBUF_USE_MMAP ? 0 : -1;
 
 	/* Allocate the main cache buffer */
 	if (!file->do_not_buffer) {
diff --git a/src/filebuf.h b/src/filebuf.h
index 044af5405c0..410fd8fe3ff 100644
--- a/src/filebuf.h
+++ b/src/filebuf.h
@@ -9,6 +9,9 @@
 
 #include "fileops.h"
 #include "hash.h"
+#ifdef GIT_WIN32
+#	include "map.h"
+#endif
 #include <zlib.h>
 
 #ifdef GIT_THREADS
@@ -20,7 +23,13 @@
 #define GIT_FILEBUF_FORCE				(1 << 3)
 #define GIT_FILEBUF_TEMPORARY			(1 << 4)
 #define GIT_FILEBUF_DO_NOT_BUFFER		(1 << 5)
+#ifdef GIT_WIN32
+#define GIT_FILEBUF_USE_MMAP			(1 << 6)
+#define GIT_FILEBUF_DEFLATE_SHIFT		(7)
+#else
+#define GIT_FILEBUF_USE_MMAP			(0)
 #define GIT_FILEBUF_DEFLATE_SHIFT		(6)
+#endif
 
 #define GIT_FILELOCK_EXTENSION ".lock\0"
 #define GIT_FILELOCK_EXTLENGTH 6
@@ -37,6 +46,10 @@ struct git_filebuf {
 	unsigned char *buffer;
 	unsigned char *z_buf;
 
+#ifdef GIT_WIN32
+	git_off_t map_pos;
+#endif
+
 	z_stream zs;
 	int flush_mode;
 
diff --git a/src/fileops.c b/src/fileops.c
index 09380e60b5e..32911c0e747 100644
--- a/src/fileops.c
+++ b/src/fileops.c
@@ -63,9 +63,9 @@ int git_futils_creat_withpath(const char *path, const mode_t dirmode, const mode
 	return fd;
 }
 
-int git_futils_creat_locked(const char *path, const mode_t mode)
+int git_futils_creat_locked(const char *path, const mode_t mode, bool rdwr)
 {
-	int fd = p_open(path, O_WRONLY | O_CREAT | O_TRUNC |
+	int fd = p_open(path, (rdwr ? O_RDWR : O_WRONLY) | O_CREAT | O_TRUNC |
 		O_EXCL | O_BINARY | O_CLOEXEC, mode);
 
 	if (fd < 0) {
diff --git a/src/fileops.h b/src/fileops.h
index 9e2ce3c8939..5420e0d28a2 100644
--- a/src/fileops.h
+++ b/src/fileops.h
@@ -44,7 +44,7 @@ extern int git_futils_creat_withpath(const char *path, const mode_t dirmode, con
 /**
  * Create an open a process-locked file
  */
-extern int git_futils_creat_locked(const char *path, const mode_t mode);
+extern int git_futils_creat_locked(const char *path, const mode_t mode, bool rdwr);
 
 /**
  * Create a path recursively
